
package de.ivu.elect.business.lokalisierung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.lokalisierung.entity.Lokalisierung;

@RequestScoped
@Named(LokalisierungConversationSelect.COMPONENT_NAME)
public class LokalisierungConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "lokalisierungConversationSelect";

  @Inject
  protected transient LokalisierungExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(LokalisierungConversationStore.class)
  protected transient LokalisierungConversationStore conversationStore;

  public LokalisierungConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Lokalisierung getEntity() {
    return getEntityInternal();
  }

  private Lokalisierung getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Lokalisierung entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.lokalisierung.entity.LokalisierungPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Lokalisierung entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.lokalisierung.entity.LokalisierungPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Lokalisierung attach(Lokalisierung entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Lokalisierung attach( de.ivu.elect.business.lokalisierung.entity.LokalisierungPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
